#! /bin/sh
#
# skeleton	example file to build /etc/init.d/ scripts.
#		This file should be used to construct scripts for /etc/init.d.
#
#		Written by Miquel van Smoorenburg <miquels@cistron.nl>.
#		Modified for Debian GNU/Linux
#		by Ian Murdock <imurdock@gnu.ai.mit.edu>.
#
# Version:	@(#)skeleton  1.8  03-Mar-1998  miquels@cistron.nl
#
# This file was automatically customized by dh-make on Mon, 17 Jan 2000 19:30:36 +0000
# Hacked into netsaint shape by bjb.

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/sbin/nagios
NAME=nagios
DESC=nagios
NICENESS=5

test -f $DAEMON || exit 0

set -e

check_started () {
#    if ps aux | grep -v grep | grep -q $DAEMON ; then
# Fix for BTS #200759 - Jeremy T. Bouse <jbouse@debian.org>
    if kill -CHLD `cat /var/run/${NAME}/${NAME}.pid` >/dev/null 2>&1 ; then
	return 0    # Is started
    else
	return 1    # Isn't started
    fi
}

check_config () {
    if $DAEMON -v /etc/nagios/nagios.cfg >/dev/null 2>&1 ; then
	return 0    # Config is ok
    else
	return 1    # Config not ok
    fi
}

case "$1" in
  start)
	echo -n "Starting $DESC: "
	if ! check_started; then
	    if check_config; then
		rm -f /var/cache/nagios/rw/nagios.cmd
		nice -$NICENESS \
		    start-stop-daemon --start --quiet \
		    --pidfile /var/run/nagios/$NAME.pid \
		    --make-pidfile --background --exec $DAEMON -- /etc/nagios/nagios.cfg
		echo "$NAME."
	    else
		echo "errors in config!"
	    fi
	else
	    echo "already running"
	fi
	;;
  stop)
	echo -n "Stopping $DESC: "
	start-stop-daemon --stop --quiet --pidfile /var/run/nagios/$NAME.pid \
		--oknodo --exec $DAEMON
	echo "$NAME."
	rm -f /var/run/nagios/$NAME.pid
	rm -f /var/cache/nagios/rw/nagios.cmd
	;;
  reload|force-reload)
	echo "Reloading $DESC configuration files."
	# Check first
	if check_config; then
	    if check_started; then
		start-stop-daemon --stop --signal 1 --quiet --pidfile \
		    /var/run/nagios/$NAME.pid --exec $DAEMON
	    else
		echo "Not running."
	    fi
	else
	    echo "Errors in config file. Not reloading."
	fi
  	;;
  restart)
	echo -n "Restarting $DESC: "
	if check_started; then
	    if check_config; then
		start-stop-daemon --stop --quiet --pidfile /var/run/nagios/$NAME.pid \
			--oknodo --exec $DAEMON || true
		sleep 2

		nice -$NICENESS \
		    start-stop-daemon --start --quiet \
			--pidfile /var/run/nagios/$NAME.pid --background --make-pidfile \
			--exec $DAEMON -- /etc/nagios/nagios.cfg
		echo "$NAME."
	    else
		echo "Errors in config file. Not restarting."
	    fi
	else
	    echo "Not running; starting."
	    exec $0 start
	fi
	;;
  *)
	N=/etc/init.d/$NAME
	echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
	exit 1
	;;
esac

exit 0
